.\" Automatically generated by Pandoc 2.5
.\"
.TH "" "" "" "" ""
.hy
.SH mkdoc::mkdoc 0.3
.SS Dr.\ Detlef Groth, Schwielowsee, Germany
.SS 2020\-02\-26
.SS NAME
.PP
\f[B]mkdoc::mkdoc\f[R] \- Tcl package and command line application to
extract and format embedded programming documentation from source code
files written in Markdown and optionally converts them into HTML.
.SS TABLE OF CONTENTS
.IP \[bu] 2
SYNOPSIS
.IP \[bu] 2
DESCRIPTION
.IP \[bu] 2
COMMAND
.IP \[bu] 2
EXAMPLE
.IP \[bu] 2
BASIC FORMATTING
.IP \[bu] 2
INSTALLATION
.IP \[bu] 2
SEE ALSO
.IP \[bu] 2
CHANGES
.IP \[bu] 2
TODO
.IP \[bu] 2
AUTHOR
.IP \[bu] 2
LICENSE AND COPYRIGHT
.SS SYNOPSIS
.PP
Usage as package:
.IP
.nf
\f[C]
package require mkdoc::mkdoc
mkdoc::mkdoc inputfile outputfile ?\-html|\-md|\-pandoc \-css file.css?
\f[R]
.fi
.PP
Usage as command line application:
.IP
.nf
\f[C]
mkdoc inputfile outputfile ?\-\-html|\-\-md|\-\-pandoc \-\-css file.css?
\f[R]
.fi
.SS DESCRIPTION
.PP
\f[B]mkdoc::mkdoc\f[R] *inputfile outputfile ?\-mode?
\-css file.css?
\- extracts embedded documentation
.PD 0
.P
.PD
from source code files.
The documentation inside the source code must be prefixed with the
\f[C]#\[aq]\f[R] character sequence.
The file extension of the output file determines the output format.
File extensions can bei either \f[C].md\f[R] for Markdown output or
\f[C].html\f[R] for html output.
The latter requires the tcllib Markdown extension to be installed.
.PP
The file \f[C]mkdoc.tcl\f[R] can be as well directly used as a console
application.
An explanation on how to do this, is given in the section Installation.
.SS COMMAND
.PP
\f[B]mkdoc::mkdoc\f[R] \f[I]infile outfile ?\-mode \-css file.css?\f[R]
.RS
.PP
Extracts the documentation in Markdown format from \f[I]infile\f[R] and
writes the documentation to \f[I]outfile\f[R] either in Markdown or HTML
format.
.RE
.RS
.IP \[bu] 2
\f[I]\-infile filename\f[R] \- file with embedded markdown documentation
.IP \[bu] 2
\f[I]\-outfile filename\f[R] \- name of output file extension
.IP \[bu] 2
\f[I]\-html\f[R] \- (mode) outfile should be a html file, not needed if
the outfile extension is html
.IP \[bu] 2
\f[I]\-md\f[R] \- (mode) outfile should be a Markdown file, not needed
if the outfile extension is md
.IP \[bu] 2
\f[I]\-pandoc\f[R] \- (mode) outfile should be a pandoc Markdown file
with YAML header, needed even if the outfile extension is md
.IP \[bu] 2
\f[I]\-css cssfile\f[R] if outfile mode is html uses the given
\f[I]cssfile\f[R]
.RE
.RS
.PP
If the \f[I]\-mode\f[R] flag (one of \-html, \-md, \-pandoc) is not
given, the output format is taken from the file extension of the output
file, either \f[I].html\f[R] for HTML or \f[I].md\f[R] for Markdown
format.
This deduction from the filetype can be overwritten giving either
\f[C]\-html\f[R] or \f[C]\-md\f[R] as command line flags.
If as mode \f[C]\-pandoc\f[R] is given, the Markdown markup code as well
contains the YAML header.
If infile has the extension .md than conversion to html will be
performed, outfile file extension In this case must be .html.
If output is html a \f[I]\-css\f[R] flag can be given to use the given
stylesheet file instead of the default style sheet embedded within the
mkdoc code.
.RE
.SS EXAMPLE
.IP
.nf
\f[C]
package require mkdoc::mkdoc
mkdoc::mkdoc mkdoc.tcl mkdoc.html
mkdoc::mkdoc mkdoc.tcl mkdoc.rmd \-md
\f[R]
.fi
.SS BASIC FORMATTING
.PP
For a complete list of Markdown formatting commands consult the basic
Markdown syntax at
https://daringfireball.net (https://daringfireball.net/projects/markdown/syntax).
Here just the most basic essentials to create documentation are
described.
Please note, that formatting blocks in Markdown are separated by an
empty line, and empty line in this documenting mode is a line prefixed
with the \f[C]#\[aq]\f[R] and nothing thereafter.
.PP
\f[B]Title and Author\f[R]
.PP
Title and author can be set at the beginning of the documentation in a
so called YAML header.
This header will be as well used by the document converter
pandoc (https://pandoc.org) to handle various options for later
processing if you extract not HTML but Markdown code from your
documentation.
.PP
A YAML header starts and ends with three hyphens.
Here is the YAML header of this document:
.IP
.nf
\f[C]
#\[aq] \-\-\-
#\[aq] title: mkdoc \- Markdown extractor and formatter
#\[aq] author: Dr. Detlef Groth, Schwielowsee, Germany
#\[aq] \-\-\-
\f[R]
.fi
.PP
Those four lines produce the two lines on top of this document.
You can extend the header if you would like to process your document
after extracting the Markdown with other tools, for instance with
Pandoc.
.PP
You can as well specify an other style sheet, than the default by adding
the following style information:
.IP
.nf
\f[C]
#\[aq] \-\-\-
#\[aq] title: mkdoc \- Markdown extractor and formatter
#\[aq] author: Dr. Detlef Groth, Schwielowsee, Germany
#\[aq] output:
#\[aq]   html_document:
#\[aq]     css: tufte.css
#\[aq] \-\-\-
\f[R]
.fi
.PP
Please note, that the indentation is required and it is two spaces.
.PP
\f[B]Headers\f[R]
.PP
Headers are prefixed with the hash symbol, single hash stands for level
1 heading, double hashes for level 2 heading, etc.
Please note, that the embedded style sheet centers level 1 and level 3
headers, there are intended to be used for the page title (h1), author
(h3) and date information (h3) on top of the page.
.IP
.nf
\f[C]
#\[aq] ## <a name=\[dq]sectionname\[dq]>Section title</a>
#\[aq]
#\[aq] Some free text that follows after the required empty 
#\[aq] line above ...
\f[R]
.fi
.PP
This produces a level 2 header.
Please note, if you have a section name \f[C]synopsis\f[R] the code
fragments thereafer will be hilighted different than the other code
fragments.
You should only use level 2 and 3 headers for the documentation.
Level 1 header are reserved for the title.
.PP
\f[B]Lists\f[R]
.PP
Lists can be given either using hyphens or stars at the beginning of a
line.
.IP
.nf
\f[C]
#\[aq] \- item 1
#\[aq] \- item 2
#\[aq] \- item 3
\f[R]
.fi
.PP
Here the output:
.IP \[bu] 2
item 1
.IP \[bu] 2
item 2
.IP \[bu] 2
item 3
.PP
A special list on top of the help page could be the table of contents
list.
Here is an example:
.IP
.nf
\f[C]
#\[aq] ## Table of Contents
#\[aq]
#\[aq] \- [Synopsis](#synopsis)
#\[aq] \- [Description](#description)
#\[aq] \- [Command](#command)
#\[aq] \- [Example](#example)
#\[aq] \- [Authors](#author)
\f[R]
.fi
.PP
This will produce in HTML mode a clickable hyperlink list.
You should however create the name targets using html code like so:
.IP
.nf
\f[C]
## <a name=\[aq]synopsis\[aq]>Synopsis</a> 
\f[R]
.fi
.PP
\f[B]Hyperlinks\f[R]
.PP
Hyperlinks are written with the following markup code:
.IP
.nf
\f[C]
[Link text](URL)
\f[R]
.fi
.PP
Let\[cq]s link to the Tcler\[cq]s Wiki:
.IP
.nf
\f[C]
[Tcler\[aq]s Wiki](https://wiki.tcl\-lang.org/)
\f[R]
.fi
.PP
produces: Tcler\[cq]s Wiki (https://wiki.tcl-lang.org/)
.PP
\f[B]Indentations\f[R]
.PP
Indentations are achieved using the greater sign:
.IP
.nf
\f[C]
#\[aq] Some text before
#\[aq]
#\[aq] > this will be indented
#\[aq]
#\[aq] This will be not indented again
\f[R]
.fi
.PP
Here the output:
.PP
Some text before
.RS
.PP
this will be indented
.RE
.PP
This will be not indented again
.PP
Also lists can be indented:
.IP
.nf
\f[C]
> \- item 1
  \- item 2
  \- item 3
\f[R]
.fi
.PP
produces:
.RS
.IP \[bu] 2
item 1
.IP \[bu] 2
item 2
.IP \[bu] 2
item 3
.RE
.PP
\f[B]Fontfaces\f[R]
.PP
Italic font face can be requested by using single stars or underlines at
the beginning and at the end of the text.
Bold is achieved by dublicating those symbols: Monospace font appears
within backticks.
Here an example:
.IP
.nf
\f[C]
I am _italic_ and I am __bold__! But I am programming code: \[ga]ls \-l\[ga]
\f[R]
.fi
.RS
.PP
I am \f[I]italic\f[R] and I am \f[B]bold\f[R]! But I am programming
code: \f[C]ls \-l\f[R]
.RE
.PP
\f[B]Code blocks\f[R]
.PP
Code blocks can be started using either three or more spaces after the
#\[cq] sequence or by embracing the code block with triple backticks on
top and on bottom.
Here an example:
.IP
.nf
\f[C]
#\[aq] \[ga]\[ga]\[ga]
#\[aq] puts \[dq]Hello World!\[dq]
#\[aq] \[ga]\[ga]\[ga]
\f[R]
.fi
.PP
Here the output:
.IP
.nf
\f[C]
puts \[dq]Hello World!\[dq]
\f[R]
.fi
.PP
\f[B]Images\f[R]
.PP
If you insist on images in your documentation, images can be embedded in
Markdown with a syntax close to links.
The links here however start with an exclamation mark:
.IP
.nf
\f[C]
![image caption](filename.png)
\f[R]
.fi
.PP
The source code of mkdoc.tcl is a good example for usage of this source
code annotation tool.
Don\[cq]t overuse the possibilities of Markdown, sometimes less is more.
Write clear and concise, don\[cq]t use fancy visual effects.
.PP
\f[B]Includes\f[R]
.PP
mkdoc in contrast to standard markdown as well support includes.
Using the \f[C]#\[aq] #include \[dq]filename.md\[dq]\f[R] syntax it is
possible to include other markdown files.
This might be useful for instance to include the same header or a footer
in a set of related files.
.SS INSTALLATION
.PP
The mkdoc::mkdoc package can be installed either as command line
application or as a Tcl module.
It requires the Markdown package from tcllib to be installed.
.PP
Installation as command line application can be done by copying the
\f[C]mkdoc.tcl\f[R] as \f[C]mkdoc\f[R] to a directory which is in your
executable path.
You should make this file executable using \f[C]chmod\f[R].
There exists as well a standalone script which does not need already
installed tcllib package.
You can download this script named: \f[C]mkdoc\-version.app\f[R] from
the chiselapp release
page (https://chiselapp.com/user/dgroth/repository/tclcode/wiki?name=releases).
.PP
Installation as Tcl module is achieved by copying the file
\f[C]mkdoc.tcl\f[R] to a place which is your Tcl module path as
\f[C]mkdoc/mkdoc\-0.1.tm\f[R] for instance.
See the tm manual page (https://www.tcl.tk/man/tcl8.6/TclCmd/tm.htm)
.SS SEE ALSO
.IP \[bu] 2
tcllib (https://core.tcl-lang.org/tcllib/doc/trunk/embedded/index.md)
for the Markdown and the textutil packages
.IP \[bu] 2
dgtools (https://chiselapp.com/user/dgroth/repository/tclcode) project
for example help page
.IP \[bu] 2
pandoc (https://pandoc.org) \- a universal document converter
.IP \[bu] 2
Ruff! (https://github.com/apnadkarni/ruff) Ruff! documentation generator
for Tcl using Markdown syntax as well
.SS CHANGES
.IP \[bu] 2
2019\-11\-19 Relase 0.1
.IP \[bu] 2
2019\-11\-22 Adding direct conversion from Markdown files to HTML files.
.IP \[bu] 2
2019\-11\-27 Documentation fixes
.IP \[bu] 2
2019\-11\-28 Kit version
.IP \[bu] 2
2019\-11\-28 Release 0.2 to fossil
.IP \[bu] 2
2019\-12\-06 Partial R\-Roxygen/Markdown support
.IP \[bu] 2
2020\-01\-05 Documentation fixes and version information
.IP \[bu] 2
2020\-02\-02 Adding include syntax
.IP \[bu] 2
2020\-02\-26 Adding stylesheet option \[en]css
.IP \[bu] 2
2020\-02\-26 Adding files pandoc.css and dgw.css
.IP \[bu] 2
2020\-02\-26 Making standalone file using pkgDeps and mk_tm
.IP \[bu] 2
2020\-02\-26 Release 0.3 to fossil
.SS TODO
.IP \[bu] 2
extract Roxygen2 documentation codes from R files??
.IP \[bu] 2
standalone files using mk_tm module maker
.IP \[bu] 2
support for \f[B]PKGVERSION\f[R] and \f[B]PKGNAME\f[R] replacements at
least in Tcl files and via command line for other file types
.SS AUTHOR(s)
.PP
The \f[B]mkdoc::mkdoc\f[R] package was written by Dr.\ Detlef Groth,
Schwielowsee, Germany.
.SS LICENSE AND COPYRIGHT
.PP
Markdown extractor and converter mkdoc::mkdoc, version
\f[B]PKGVERSION\f[R]
.PP
Copyright (c) 2019\-20 Dr.\ Detlef Groth, E\-mail:
<detlef(at)dgroth(dot)de>
.PP
This library is free software; you can use, modify, and redistribute it
for any purpose, provided that existing copyright notices are retained
in all copies and that this notice is included verbatim in any
distributions.
.PP
This software is distributed WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
